' SpeedCamera Distance Converter
' PoPo 02.03.2007
' Version 2.02


OPTION Explicit

' **** Init
WScript.Echo "SpeedCamera Distance Converter v2.02, PoPo - Switzerland"
WScript.Echo "GARMIN CSV to GPX - POI Loader Workaround"

Dim oFSO, strRootDir, strIniFile, oFolder, oFiles, oFile, strExt
Dim strInputFolder, strOutputFolder, strCopyMP3
Dim strInputFile, strOutputFile, strDistance
Dim strInfo
Public bisRedlight 

' **** First Use Check and Read INI
Set oFSO = CreateObject("Scripting.FileSystemObject")
strRootDir = oFSO.GetParentFolderName(WScript.ScriptFullName)
strIniFile = strRootDir & "\distconv.ini"
If Not (oFSO.FileExists(strIniFile)) Then
  strInputFolder = strRootDir & "\input"
  strOutputFolder = strRootDir & "\output"
  strCopyMP3="0"
  WriteProfileString "Distconv", "InputFolder", strIniFile, strInputFolder
  WriteProfileString "Distconv", "OutputFolder", strIniFile, strOutputFolder
  WriteProfileString "Distconv", "CopyMP3", strIniFile, strCopyMP3
Else
  strInputFolder = GetProfileString("Distconv","InputFolder",strIniFile)
  strOutputFolder = GetProfileString("Distconv","OutputFolder",strIniFile)
  strCopyMP3 = GetProfileString("Distconv","CopyMP3",strIniFile)
End If
WScript.Echo "Input Folder : " & strInputFolder
WScript.Echo "Output Folder: " & strOutputFolder
WScript.Echo "---------------------------------------------------------"

' **** Delete Output Folder
On Error Resume Next
Set oFolder = oFSO.GetFolder(strOutputFolder)
Set oFiles = oFolder.Files
For Each oFile In oFiles
  strExt = UCase(oFSO.GetExtensionName(oFile))
  If strExt = "GPX" Or strExt = "BMP" Or strExt = "MP3" Then
    oFile.Delete
  End If
Next

' **** Processing Input Folder
Set oFolder = oFSO.GetFolder(strInputFolder)
Set oFiles = oFolder.Files
For Each oFile In oFiles
  strExt = UCase(oFSO.GetExtensionName(oFile))
  If strExt = "CSV" Then
    strDistance = GetDistance(oFSO.GetBaseName(oFile))
    strInputFile = oFile
    strOutputFile = GetOutputFileName(strOutputFolder, oFSO.GetBaseName(oFile))
    strInfo = oFSO.GetBaseName(oFile) & ": "
    strInfo = strInfo & ConvertToGPX(strInputFile, strOutputFile, strDistance)
    strInfo = strInfo & CopyBMP(strInputFile, strOutputFile)
    If strCopyMP3 = "1" Then
      strInfo = strInfo & CopyMP3(strInputFile, strOutputFile)
    End If
    WScript.Echo strInfo
  End If
Next

' **** Get Distance
Function GetDistance(strBaseName)
  Dim strDist, ifirstnumber, ilastnumber, bset, i
  strDist = GetProfileString("Distance",strBaseName,strIniFile)
  If strDist = "" Then
    ifirstnumber=0
    ilastnumber=0
    bset=false
    For i=1 To Len(strBaseName)
      If IsNumeric(Mid(strBaseName,i,1)) Then
        If bset=False Then ilastnumber = i
        If ifirstnumber = 0 Then ifirstnumber = i
      Else
        If ilastnumber <> 0 Then bset=true
      End If
    Next
    If ifirstnumber=0 Then
      strDist="400"
      bisRedlight = True
    Else
      strDist=Mid(strBaseName,ifirstnumber,ilastnumber-ifirstnumber+1)*5
      bisRedlight = False
    End If
    WriteProfileString "Distance", strBaseName, strIniFile, strDist
  End If
  GetDistance = strDist  
End Function

' **** Get OutputFileName
Function GetOutputFileName(strOutputFolder, strBaseName)
  Dim strFName
  strFName = GetProfileString("Rename",strBaseName,strIniFile)
  If strFName = "" Then
    strFName = strBaseName
    If Not bisRedlight Then strFName = Replace(strFName, "Redlight", "Red", 1, -1, 1)
    If Not bisRedlight Then strFName = Replace(strFName, "rote Ampel", "Rotlicht", 1, -1, 1)
    WriteProfileString "Rename", strBaseName, strIniFile, strFName
  End If  
  GetOutputFileName = strOutputFolder & "\" & strFName & ".gpx"
End Function

' **** Convert
Function ConvertToGPX(strInputFile, strOutputFile, strDistance)

  ' **** Declarations
  Dim oInputFile, oOutputFile
  Dim oFSO, i, strLine, arrPOI, strDesc
  Const ForReading = 1

  ' **** Open/Create Files
  Set oFSO = CreateObject("Scripting.FileSystemObject")
  Set oInputFile = oFSO.OpenTextFile(strInputFile, ForReading)
  Set oOutputFile = oFSO.CreateTextFile(strOutputFile, True)
  
  On Error Resume Next
  
  ' **** Convert File
  i = 0
  oOutputFile.WriteLine("<?xml version=""1.0"" encoding=""ISO-8859-1"" standalone=""no"" ?>")
  oOutputFile.WriteLine("<gpx xmlns=""http://www.topografix.com/GPX/1/1"" creator=""DistConv"" version=""1.1"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:schemaLocation=""http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd"">")
  
  Do While oInputFile.AtEndOfStream <> True
    strLine = reformat(oInputFile.ReadLine)
    If inStr(strLine, Chr(9)) Then
      arrPOI = split(strLine, Chr(9))
      oOutputFile.WriteLine("")
      oOutputFile.WriteLine("  <wpt lat=""" & arrPOI(1) & """ lon=""" & arrPOI(0) & """>")
      oOutputFile.WriteLine("    <name>" & arrPOI(2) & "</name>")
      strDesc = ""
      strDesc = arrPOI(3)
      'oOutputFile.WriteLine("    <cmt>" & strDesc & "</cmt>")
      oOutputFile.WriteLine("    <desc>" & strDesc & "</desc>")
      oOutputFile.WriteLine("    <extensions>")
      oOutputFile.WriteLine("      <gpxx:WaypointExtension xmlns:gpxx=""http://www.garmin.com/xmlschemas/GpxExtensions/v2"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:schemaLocation=""http://www.garmin.com/xmlschemas/GpxExtensions/v2 http://www.garmin.com/xmlschemas/GpxExtensions/v2/GpxExtensionsv2.xsd"">")
      oOutputFile.WriteLine("        <gpxx:Proximity>"& strDistance &"</gpxx:Proximity>")
      oOutputFile.WriteLine("      </gpxx:WaypointExtension>")
      oOutputFile.WriteLine("    </extensions>")
      oOutputFile.WriteLine("  </wpt>")
      i = i + 1
    End If
  Loop

  oOutputFile.WriteLine("")
  oOutputFile.WriteLine("</gpx>")
  
  ' **** Close Files
  oInputFile.Close
  oOutputFile.Close
  Set oFSO = Nothing
  ConvertToGPX = i & " POIs converted"

End Function

' **** Reformat Function
Function reformat(strinput)
  Dim stroutput, c, intext
  stroutput = ""
  intext = False
  For c = 1 To Len(strinput)
    If Mid(strinput,c,1) = Chr(34) Then
      If intext=True Then intext=False Else intext=True
    Else
      If intext=False And Mid(strinput,c,1) = "," Then
        stroutput = stroutput + Chr(9)
      Else
        Select Case Mid(strinput,c,1)
        Case "&"
          stroutput = stroutput + "&amp;"
        Case "<"
          stroutput = stroutput + "&lt;"
        Case ">"
          stroutput = stroutput + "&gt;"
        Case Else
          stroutput = stroutput + Mid(strinput,c,1)
        End Select
      End If
    End If 
  Next
  reformat = stroutput
End Function

' **** Copy BMP
Function CopyBMP(strInputFile, strOutputFile)
  Dim strInputBMP, strOutputBMP, oFSO
  On Error Resume Next
  strInputBMP = Left(strInputFile, Len(strInputFile)-3) & "bmp"
  strOutputBMP = Left(strOutputFile, Len(strOutputFile)-3) & "bmp"
  Set oFSO = CreateObject("Scripting.FileSystemObject")
  If oFSO.FileExists(strInputBMP) Then
    oFSO.CopyFile strInputBMP, strOutputBMP, True
    CopyBMP = ", BMP"
  Else
    CopyBMP = ", No BMP!"
  End If
End Function

' **** Copy MP3
Function CopyMP3(strInputFile, strOutputFile)
  Dim strInputMP3, strOutputMP3, oFSO
  On Error Resume Next
  strInputMP3 = Left(strInputFile, Len(strInputFile)-3) & "mp3"
  strOutputMP3 = Left(strOutputFile, Len(strOutputFile)-3) & "mp3"
  Set oFSO = CreateObject("Scripting.FileSystemObject")
  If oFSO.FileExists(strInputMP3) Then
    oFSO.CopyFile strInputMP3, strOutputMP3, True
    CopyMP3 = ", MP3"
  Else
    CopyMP3 = ""
  End If
End Function


' **** Write INI File
Sub WriteProfileString(section,key,filename,value)
  
  If MyTrim(section)="" Or Mytrim(key)="" then
    Exit Sub
  End if
    
  dim contentini, fso
  Set fso = CreateObject("Scripting.FileSystemObject")
  contentini=""
  
  if fso.FileExists(filename) then
    Dim readini,bsection,bSectionFound,bKeyFound
    bKeyFound=False
    bsection=False
    bsectionFound=False
    
    Set readini = fso.OpenTextFile(filename,1)
    Do while not(readini.AtEndOfStream)
      Dim strini,trimstrini
      strini = readini.ReadLine
      trimstrini = MyTrim(strini)
      if Left(trimstrini,1)="[" and Right(Trimstrini,1)="]" then
        if StrComp(Trimstrini,"[" & MyTrim(section) & "]",1)=0 Then
          bsection=True
          bsectionFound=True
        else
          bsection =False
        end if
      Else
        if bsection then
          Dim poskey
          poskey = InStr(Trimstrini,"=")
          if posKey>0 then
            if StrComp(MyTrim(Left(Trimstrini,poskey-1)),MyTrim(key),1)=0 Then
              bKeyFound = True
              strini = Left(Trimstrini,poskey) & " " & value
            end If  
          End if
        end if
      End if
      
      if bsectionFound=True and bsection=False and bKeyFound=false then
        contentini = contentini & key & "=" & value & vbcrlf
        bKeyFound = True
      end if
      
      if MyTrim(strini)<>"" then
        if Left(trimstrini,1)="[" and Right(Trimstrini,1)="]" And contentini<>"" then
          contentini = contentini & vbCrlf
        end if
        
        contentini = contentini & strini & vbCrlf
      end if
    Loop

    if bsectionFound=True and bsection=True and bKeyfound =false then
      contentini = contentini & key & "=" & value & vbcrlf
    end if
    
    if bsectionFound=False Then
      contentini = contentini & vbcrlf & "[" & section & "]" & vbcrlf & key & "=" & value & vbcrlf
    end if
    
    readini.Close
    
  Else
    contentini = "[" & section & "]" & vbcrlf & key & "=" & value & vbcrlf
  End if
  
  Dim writeini 
  set writeini = fso.CreateTextFile(filename,True)
  writeini.Write contentini
  writeini.Close
End Sub

' **** Read INI File
Function GetProfileString(section,key,filename)
  Dim fso
  Set fso = CreateObject("Scripting.FileSystemObject")
  If fso.FileExists(filename) Then

    Dim readini,bsection
    bsection=False
    
    Set readini = fso.OpenTextFile(filename,1)
    Do while not(readini.AtEndOfStream)
      Dim strini,trimstrini
      strini = readini.ReadLine
      trimstrini = MyTrim(strini)
      if Left(trimstrini,1)="[" and Right(Trimstrini,1)="]" then
        if StrComp(Trimstrini,"[" & MyTrim(section) & "]",1)=0 Then
          bsection=True
        else
          bsection =False
        end if
      Else
        if bsection then
          Dim poskey
          poskey = InStr(Trimstrini,"=")
          if posKey>0 then
            if StrComp(MyTrim(Left(Trimstrini,poskey-1)),MyTrim(key),1)=0 Then
              GetProfileString = MyTrim(Mid(Trimstrini,poskey+1))
              Exit Function
            end If  
          End if
        end if
      End if
    Loop
  End if
  
  GetProfileString = ""
End Function

' **** Trim for Read/Write INI File
Function MyTrim(mystring)
  Dim start,Endpos, i
  start=1
  for i=1 to Len(mystring)
    if Mid(mystring,i,1)=vbTab or Mid(mystring,i,1)=" " Then
      start=i+1
    else
      exit for
    end if
  next
  Endpos=Len(mystring)
  for i=Len(mystring) to 1 step -1
    if Mid(mystring,i,1)=vbTab or Mid(mystring,i,1)=" " Then
      Endpos=i-1
    else
      exit for
    end if
  next
  if (endpos-start+1)<0 then
    MyTrim=""
    Exit Function
  end if
  MyTrim=Mid(mystring,start,Endpos-start+1)
End Function

' **** END OF DISTCONV